//Giving names to the each node of the equus asinus species network
const Data = {
  "name": "Dinohippus",
  "value": 9,
  "type": "black",
  "level": "darkkhaki",
  "children": [
    {  
      "name": "Horse",
      "value": 9,
      "type": "orange",
      "level": "deeppink",
      "children": [
        //To Name the sub unit of the Horse
        {
          "name": "Equus Caballus",
          "value": 9,
          "type": "red",
          "level": "blueviolet",
          "children":[
            //To Name the sub units of Equus Caballus
            {
              "name": "E.CaballusLibycus",
              "value": 9,
               "type": "brown",
               "level": "seagreen",
            },
            {
              "name": "E.Caballusgermanicus",
              "value": 9,
               "type": "brown",
               "level": "seagreen",
            },
                  ]
  },
        
        ]
    },
    {
      //To Name the second sub unit of Dinohippus
      "name": "Donkey",
      "value": 9,
      "type": "orange",
      "level": "deeppink",
      "children": [
         {
           
      //Naming the first sub unit of Donkey
          "name": "Equus africanus",
          "value": 9,
          "type": "red",
          "level": "blueviolet",
          "children":[
            {
              "name": "E.africanus somaliensis",
              "value": 9,
               "type": "brown",
               "level": "seagreen",
            },
            {
              "name": "E.africanus africanus",
              "value": 9,
               "type": "brown",
               "level": "seagreen",
            }, 
      ]
    },
         {
           //To Name the second sub unit of Donkey
          "name": "Equus heminonus",
          "value": 9,
          "type": "red",
          "level": "blueviolet",
           "children": [
           {
          "name": "Equus hemionus hemippus",
          "value": 9,
          "type": "brown",
          "level": "seagreen",
           },
             
           {
          "name": "Equus asinuskiang",
          "value": 9,
          "type": "brown",
          "level": "seagreen",
           },  
             {
          "name": "Asian ass",
          "value": 9,
          "type": "brown",
          "level": "seagreen",
           }
      ]
    },
        ]
    },
        {
          // To Name the third sub unit of Dinohippus
          "name": "Zebra",
          "value": 9,
          "type": "orange",
          "level": "deeppink",
           "children": [
           {
             //To name the first sub unit of Zebra
          "name": "Equus guagga",
          "value": 9,
          "type": "red",
          "level": "blueviolet",
          },
         {
          "name": "Equuszebra",
          "value": 9,
          "type": "red",
          "level": "blueviolet"
        },
          {
          "name": "Equus grevy",
          "value": 9,
          "type": "red",
          "level": "blueviolet"
        },
      ]
    },
  
      
    ]
};

//Defining width,height and margin of the Equus asinus species network
const margin = {top: 10, right: 250, bottom:200, left: 200},
      width  = 850 - margin.left - margin.right,
      height = 650 - margin.top - margin.bottom;

const tree = d3.tree().size([height, width]);

//Assigning heirarchical structure to classify the data
let nodes = d3.hierarchy(Data, node => node.children);

//Providing data connection for nodes to their respective position in the species network
nodes = tree(nodes);

//Adding an svg element
const svg = d3.select("body").append("svg")
        .attr("width", width + margin.left + margin.right)
        .attr("height", height + margin.top + margin.bottom),
      g = svg.append("g")//appends group
        .attr("transform",
            "translate(" + margin.left + "," + margin.top + ")");

//Defining links between nodes
const link = g.selectAll(".link")
    .data( nodes.descendants().slice(1))
  .enter().append("path")
    .attr("class", "link")
    .style("stroke", d => d.data.level)
    .attr("d", d => {
       return "M" + d.y + "," + d.x
         + "C" + (d.y + d.parent.y) / 2 + "," + d.x
         + " " + (d.y + d.parent.y) / 2 + "," + d.parent.x
         + " " + d.parent.y + "," + d.parent.x;
       });

//Declaring a group for each node present in the species network
const node = g.selectAll(".node")
    .data(nodes.descendants())
    .enter().append("g")
    .attr("class", d => "node" + (d.children ? " node--internal" : " node--leaf"))
    .attr("transform", d => "translate(" + d.y + "," + d.x + ")");

//Defining shape of the node
node.append("circle")
  .attr("r", d => d.data.value)
  .style("stroke", d => d.data.type)
  .style("fill", d => d.data.level);
  
//Adding a new node to the list
node.append("text")
  .attr("dy", ".60em")
  .attr("x", d => d.children ? (d.data.value + 5) * -1 : d.data.value + 5)
  .attr("y", d => d.children && d.depth !== 0 ? -(d.data.value + 5) : d)
  .style("text-anchor", d => d.children ? "end" : "start")
  .text(d => d.data.name);